package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @DESCRIPTION: 松下工位节拍采集记录
 * @USER: wangjie
 * @DATE: 2023-02-03 16:11
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "SX_WORK_CELL_TAKT_COLLECT_RECORD", indexes = {
        @Index(columnList = "SYSTEM_SYNC_STATUS"),
        @Index(columnList = "WORK_CENTER_CODE"),
        @Index(columnList = "WORK_CELL_CODE")
})
@Api("松下工位节拍采集")
public class SxWorkCellTaktCollectRecord extends BaseBean implements Serializable {

    private static final long serialVersionUID = -4200275306063660152L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线代码")
    private String workCenterCode;

    @Column(name = "WORK_CELL_CODE")
    @ApiParam("工位代码")
    private String workCellCode;

    @Column(name = "WORK_TAKT")
    @ApiParam("生产节拍")
    private String workTakt;

    @Column(name = "SYSTEM_SYNC_STATUS")
    @ColumnDefault("2")
    @ApiParam(value = "系统同步标志")
    public Integer systemSyncStatus = 2;

}

